/*	Application		Adder			
	File			Adder.Java 
	Purpose			Demonstration of a simple program, stream IO, pipes 
	Author			Richard John Anthony
	Date			January 2015
	
	Function		1. Accepts two numbers typed on the keyboard
				2. Adds the numbers together
				3. Outputs the sum of the two numbers

       For the pipeline experiment please use either the C++ or C# versions of this application
*/
import java.io.Console;
import java.io.IOException;

public class Adder
{
    public static void main(String[] args)
    {
        Console con = System.console();
        if (null == con)
        {
            System.out.println("!! Error accessing console: Run in a command window !!");
            return;
        }
        
        // Input two numbers from the input stream
        String sFirstNumber = con.readLine();
        String sSecondNumber = con.readLine();	
        int iFirstNumber = Integer.parseInt(sFirstNumber);;
        int iSecondNumber = Integer.parseInt(sSecondNumber);;	

        // Add the numbers
        int iTotal = iFirstNumber + iSecondNumber;

        // Output the result onto the output stream
        con.printf("%d", iTotal);

        // Note that this process will exit immediately after printing the total onto the output stream.
        // To run the project from the command line, go to the dist folder and type: java -jar "Adder.jar" 
     }
}

