/*	Application		A CPU hogger
	File			CPU_Hog.java
	Purpose			A CPU-intensive program which is used to demonstrate attributes of scheduler behaviour
	Author			Richard John Anthony
	Date			January 2015
	
	Function		Runs in a CPU-intense loop to use CPU cycles (performs no IO so never blocks, always uses its full time slice)

        Run the project from the command line, go to the dist folder and type: java -jar "CPU_Hog.jar" 
*/
package cpu_hog;

public class CPU_Hog
{
    public static void main(String[] args)
    {
        int i, j, k;
        i = 0;
        j = 1;
        k = 2;
        for (long iOuterLoop = 0; iOuterLoop < 500000; iOuterLoop++)
        {
            // Note, the Java version runs considerably slower than the C# and C++ versions with the
            // same innerloop count (100000). The Java version takes approcimately four times as long
            // to run with the same loop count as the C++ version. To ensure a comparable run time for 
            // the experiments in chapter 2, the loop count has been reduced in the Java version.
            for (long iInnerLoop = 0; iInnerLoop < 26000; iInnerLoop++)
            {
                // Make sure that the compiler doesn't optimise the loop away
                // It is non-trivial to determine that the computation done here has
                // no overall effect because each variable is used on a LHS and a RHS
                i += j;
                j += k;
                k += i;
            }
        }
    }
}

