/*	Application		Doubler			
	File			Doubler.Java 
	Purpose			Demonstration of a simple program, stream IO, pipes 
	Author			Richard John Anthony
	Date			January 2015
	
	Function		1. Accepts one number typed on the keyboard
                                2. Doubles the value of the number
				3. Outputs the result
        
        For the pipeline experiment please use either the C++ or C# versions of this application
*/

package doubler;

import java.io.Console;
import java.io.IOException;

public class Doubler
{
    public static void main(String[] args)
    {
        Console con = System.console();
        if (null == con)
        {
            System.out.println("!! Error accessing console: Run in a command window !!");
            return;
        }
        
        // Input a number from the input stream
        String sNumber = con.readLine();
        int iNumber = Integer.parseInt(sNumber);
 
        // Multiply the number by 2
        int iTotal = iNumber * 2;

        // Output the result onto the output stream
        con.printf("%d", iTotal);

        // Note that this process will exit immediately after printing the total onto the output stream.
        // To run the project from the command line, go to the dist folder and type: java -jar "Doubler.jar" 
    }
}