/*	Application		Socket-based IPC threads example	
	File			Receive_Thread.java
	Purpose			Demonstration of local IPC, and multithreading using a blocking socket
	Author			Richard John Anthony
	Date			February 2015
*/

package Multithreaded_IPC_two_worker_threads;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;

public class Receive_Thread  implements Runnable
{
    Thread m_RecvThread;
    
    // Dedicated flags are used, one to run/stop each thread, to prevent access races
    public static Boolean m_bRecvThread_Running = false;
    
    Receive_Thread()
    {
        m_RecvThread = new Thread(this); // Create the receiver thread
    }

    public void Start()
    {   // The means of externally calling the thread's start() method (which invokes run()).
        m_RecvThread.start();
    }

    public void run()
    {
        while (true)// == m_bRecvThread_Running)
        {
            if(true == m_bRecvThread_Running)
            {
                ReadMessageFromReceiveBufferOrWait();
            }
        }
    }

    String ReadMessageFromReceiveBufferOrWait()
    {
        String sReceivedStr = "";
        System.out.println("ReceiveThread: Waiting for message ...   ");
        try
        {
            byte[] bRecvBuf = new byte[Multithreaded_IPC_two_worker_threads.BUFFER_SIZE];
            DatagramPacket RecvPacket = new DatagramPacket(bRecvBuf, Multithreaded_IPC_two_worker_threads.BUFFER_SIZE);
            Multithreaded_IPC_two_worker_threads.m_IPC_RecvSOCKET.receive(RecvPacket);
            sReceivedStr = new String(RecvPacket.getData(), 0, RecvPacket.getLength());  
            System.out.printf("RecvThread  Received: %s   number of bytes received: %d\n", sReceivedStr, sReceivedStr.length());
        }
        catch(Exception Ex)
        {
            if(true == m_bRecvThread_Running) // Test again, as the flag may have become set whilst this thread was blocked
            {
                System.out.printf("Receive failed: %s\n", Ex.toString());
                Multithreaded_IPC_two_worker_threads.CloseSocketsAndExit(true);
            }
        }
        return sReceivedStr;
    }
}