/*	Application		Timers Demonstration - Timer event handlers executed asynchronously with respect to main()			
	File			Timers_Demonstration.Java
	Purpose			Demonstrates the basic concepts of programmable timers and event handlers
	Author			Richard John Anthony
	Date			January 2014
	
	Function		Creates three timers with periods of 1 second, 2 seconds and 3 seconds respectively

        To run the project from the command line go to the dist folder and type: java -jar "Timers_Demonstration.jar"
*/

package Timers_Demonstration;

import java.util.Timer;
import java.util.TimerTask;

public class Timers_Demonstration
{
    Timer m_Timer;

    public Timers_Demonstration(int milliseconds, String sDisplayString) 
    {   // Create and configure a timer; in this example the task is scheduled periodically (repeated at a fixed rate)
        m_Timer = new Timer();
        m_Timer.scheduleAtFixedRate(new TimedEvent(sDisplayString), milliseconds, milliseconds);
    }

    
    class TimedEvent extends TimerTask 
    {   // Configure the timer task 
        private String m_sDisplayString;  

        public TimedEvent(String sDisplayString) 
        {
            m_sDisplayString = sDisplayString;
        }

        public void run()
        {
            System.out.println(m_sDisplayString);
        }
    }

    
    public static void main(String[] args)
    {   // Create three Timers_Demonstration objects with different periods and display strings
        new Timers_Demonstration(1000/*period, in milliseconds*/,"One second"/*String to display*/);   
        new Timers_Demonstration(2000/*period, in milliseconds*/,"            Two seconds"/*String to display*/);   
        new Timers_Demonstration(3000/*period, in milliseconds*/,"                         Three seconds"/*String to display*/);   
        while (true)
        {   // main thread does nothing in this example
        }
    }
}
